## pyopencl 2025.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17...3.26)

project(pyopencl LANGUAGES CXX VERSION ${SKBUILD_PROJECT_VERSION})

if(NOT SKBUILD)
  message(WARNING "\
  This CMake file is meant to be executed using 'scikit-build'. Running
  it directly will almost certainly not produce the desired result. If
  you are a user trying to install this package, please use the command
  below, which will install all necessary build dependencies, compile
  the package in an isolated environment, and then install it.
  =====================================================================
   $ pip install .
  =====================================================================
  If you are a software developer, and this is your own package, then
  it is usually much more efficient to install the build dependencies
  in your environment once and use the following command that avoids
  a costly creation of a new virtual environment at every compilation:
  =====================================================================
   $ pip install nanobind scikit-build-core[pyproject]
   $ pip install --no-build-isolation -ve .
  =====================================================================
  You may optionally add -Ceditable.rebuild=true to auto-rebuild when
  the package is imported. Otherwise, you need to re-run the above
  after editing C++ files.")
endif()

# {{{ Options

option(PYOPENCL_TRACE "Enable OpenCL tracing" $ENV{PYOPENCL_TRACE})
option(PYOPENCL_ENABLE_GL "Enable OpenGL interoperability" $ENV{PYOPENCL_ENABLE_GL})
option(PYOPENCL_USE_SHIPPED_EXT "Use shipped CL extension header" $ENV{PYOPENCL_USE_SHIPPED_EXT})

set(CL_INC_DIR CACHE STRING "OpenCL include directory")
set(CL_LIB_DIR CACHE STRING "OpenCL library directory")
set(CL_LIBNAME CACHE STRING "OpenCL library name")

set(PYOPENCL_PRETEND_CL_VERSION CACHE STRING "Pretend to be a different OpenCL version")

if(NOT CL_INC_DIR)
  message(STATUS "CL_INC_DIR not set, trying to guess it from environment variables.")
  if(DEFINED ENV{CL_INC_DIR})
    message(STATUS "Using OpenCL include directory from environment '$ENV{CL_INC_DIR}'")
    set(CL_INC_DIR $ENV{CL_INC_DIR})
  endif()

  if(DEFINED ENV{CL_LIB_DIR})
    message(STATUS "Using OpenCL library directory from environment '$ENV{CL_INC_DIR}'")
    set(CL_LIB_DIR $ENV{CL_LIB_DIR})
  endif()

  if(DEFINED ENV{CL_LIBNAME})
    message(STATUS "Using OpenCL library name from environment '$ENV{CL_LIBNAME}'")
    set(CL_LIBNAME $ENV{CL_LIBNAME})
  endif()
endif(NOT CL_INC_DIR)

if(NOT CL_INC_DIR)
  message(STATUS "CL_INC_DIR not set, trying to guess it from conda environment.")
  if(DEFINED ENV{CONDA_PREFIX})
    # Linux/MacOS:
    if(EXISTS $ENV{CONDA_PREFIX}/lib/libOpenCL${CMAKE_SHARED_LIBRARY_SUFFIX})
      message(STATUS "Found OpenCL in conda environment '$ENV{CONDA_PREFIX}'")
      set(CL_INC_DIR $ENV{CONDA_PREFIX}/include)
      set(CL_LIB_DIR $ENV{CONDA_PREFIX}/lib)
      set(CL_LIBNAME OpenCL)
    # Windows:
    elseif(EXISTS $ENV{CONDA_PREFIX}/Library/lib/OpenCL${CMAKE_STATIC_LIBRARY_SUFFIX})
      message(STATUS "Found OpenCL in conda environment '$ENV{CONDA_PREFIX}'")
      set(CL_INC_DIR $ENV{CONDA_PREFIX}/Library/include)
      set(CL_LIB_DIR $ENV{CONDA_PREFIX}/Library/lib)
      set(CL_LIBNAME OpenCL)
    endif()

  endif(DEFINED ENV{CONDA_PREFIX})
endif(NOT CL_INC_DIR)

if(NOT PYOPENCL_PRETEND_CL_VERSION)
  if(DEFINED ENV{PYOPENCL_PRETEND_CL_VERSION})
    set(PYOPENCL_PRETEND_CL_VERSION $ENV{PYOPENCL_PRETEND_CL_VERSION})
  endif()
endif()

if(PYOPENCL_PRETEND_CL_VERSION)
  # Split the version string into a list
  string(REPLACE "." ";" VERSION_LIST ${PYOPENCL_PRETEND_CL_VERSION})

  # Get the major and minor version numbers
  list(GET VERSION_LIST 0 MAJOR)
  list(GET VERSION_LIST 1 MINOR)

  # Calculate the numerical value
  math(EXPR ARG "0x1000*${MAJOR} + 0x10*${MINOR}")
  message(STATUS "Pretending to use OpenCL version ${PYOPENCL_PRETEND_CL_VERSION} (${ARG})")
  set(PYOPENCL_PRETEND_CL_VERSION ${ARG})
endif()

message(STATUS "CL_INC_DIR ${CL_INC_DIR}")
message(STATUS "CL_LIB_DIR ${CL_LIB_DIR}")
message(STATUS "CL_LIBNAME ${CL_LIBNAME}")

# }}}

# {{{ Get version information

find_program(GIT git)

if(GIT AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
  # Exact tag match => released version
  execute_process(COMMAND git describe --exact-match --dirty=*
             OUTPUT_VARIABLE PYOPENCL_VERSION_GIT
             RESULT_VARIABLE git_result
             OUTPUT_STRIP_TRAILING_WHITESPACE
             ERROR_QUIET
             )
  if(NOT ${git_result} EQUAL 0)
    # No exact tag match => development version
    execute_process(COMMAND git describe --long --always --dirty=*
             OUTPUT_VARIABLE PYOPENCL_VERSION_GIT
             OUTPUT_STRIP_TRAILING_WHITESPACE
             )
    set(PYOPENCL_REL "(dev)")
  else()
    set(PYOPENCL_REL "(release)")
  endif()
else()
  set(PYOPENCL_VERSION_GIT "v${PROJECT_VERSION}")
  set(PYOPENCL_REL "(non-git)")
endif()

# }}}

find_package(Python COMPONENTS Interpreter Development.Module NumPy REQUIRED)

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# {{{ Detect nanobind and import it

execute_process(
  COMMAND
  "${PYTHON_EXECUTABLE}" -c "import nanobind; print(nanobind.__version__)"
  OUTPUT_VARIABLE NANOBIND_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT)

execute_process(
  COMMAND
  "${PYTHON_EXECUTABLE}" -c "import nanobind; print(nanobind.cmake_dir())"
  OUTPUT_VARIABLE NANOBIND_DIR
  OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT)
  list(APPEND CMAKE_PREFIX_PATH "${NANOBIND_DIR}")

# }}}

link_directories(${CL_LIB_DIR})
include_directories(${CL_INC_DIR} ${Python_NumPy_INCLUDE_DIRS})

find_package(nanobind CONFIG REQUIRED)

set(OpenCL_ROOT ${CL_LIB_DIR})
set(OpenCL_INCLUDE_DIR ${CL_INC_DIR})
set(OpenCL_LIBRARY ${CL_LIBNAME})
find_package(OpenCL REQUIRED)

nanobind_add_module(
  _cl
  NB_STATIC # Build static libnanobind (the extension module itself remains a shared library)
  LTO
  NOMINSIZE
  src/wrap_constants.cpp
  src/wrap_cl.cpp
  src/wrap_cl_part_1.cpp
  src/wrap_cl_part_2.cpp
  src/wrap_mempool.cpp
  src/bitlog.cpp
)

target_link_libraries(_cl PRIVATE ${OpenCL_LIBRARY})

target_compile_definitions(_cl
  PRIVATE
  PYGPU_PACKAGE=pyopencl
  PYGPU_PYOPENCL
)

if (PYOPENCL_PRETEND_CL_VERSION)
  target_compile_definitions(
    _cl PRIVATE PYOPENCL_PRETEND_CL_VERSION=${PYOPENCL_PRETEND_CL_VERSION})
endif()

if (PYOPENCL_ENABLE_GL)
  target_compile_definitions(_cl PRIVATE HAVE_GL=1)
endif()

if (PYOPENCL_TRACE)
  target_compile_definitions(_cl PRIVATE PYOPENCL_TRACE=1)
endif()

if (PYOPENCL_USE_SHIPPED_EXT)
  target_compile_definitions(_cl PRIVATE PYOPENCL_USE_SHIPPED_EXT=1)
endif()

install(TARGETS _cl LIBRARY DESTINATION pyopencl)


# {{{ Print configuration

message("==============================")
message("PyOpenCL ${PYOPENCL_VERSION_GIT} ${PYOPENCL_REL} configuration: ")
message("  PyOpenCL options: PYOPENCL_TRACE=${PYOPENCL_TRACE} PYOPENCL_ENABLE_GL=${PYOPENCL_ENABLE_GL} PYOPENCL_USE_SHIPPED_EXT=${PYOPENCL_USE_SHIPPED_EXT} PYOPENCL_PRETEND_CL_VERSION=${PYOPENCL_PRETEND_CL_VERSION}")
message("  OpenCL:           ${OpenCL_LIBRARIES} [${OpenCL_VERSION_STRING}]")
message("  Python:           ${Python_EXECUTABLE} [${Python_VERSION}]")
message("  Build type:       ${CMAKE_BUILD_TYPE}")
message("  C++ compiler:     ${CMAKE_CXX_COMPILER} [${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}]")
message("  CMake:            ${CMAKE_COMMAND} [${CMAKE_VERSION}]")
message("  Nanobind:         ${NANOBIND_DIR} [${NANOBIND_VERSION}]")
message("  Build tool:       ${CMAKE_MAKE_PROGRAM}")
message("==============================")

# }}}

# vim: foldmethod=marker:sw=2

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -W -n
SPHINXBUILD   ?= python $(shell which sphinx-build)
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

constants:
	python make_constants.py > constants.inc

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile constants
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
pyopencl (2025.1-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1083134)
  * Refresh patches.
  * Switch B-D from python3-pybind11 to python3-nanobind.
  * Switch B-D from python3-setuptools to python3-scikit-build-core and cmake.
  * Upstream changed buildsystem backend to scikit-build-core.
  * Update dependency on pytools to 2024.1.5.
  * Update Standards-Version to 4.7.2; no changes necessary.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Apr 2025 12:07:22 +0200

=== debian/control ===
Source: pyopencl
Section: python
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Tomasz Rybak <serpent@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-numpy3,
 dh-sequence-python3,
 cmake,
 ocl-icd-opencl-dev | opencl-dev,
 opencl-c-headers,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-nanobind,
 python3-scikit-build-core,
# only for running the tests
 pocl-opencl-icd [amd64 arm64 armel armhf i386 hurd-i386] <!nocheck> | mesa-opencl-icd <!nocheck>,
 python3-mako <!nocheck>,
 python3-pytest (>= 7) <!nocheck>,
 python3-pytools (>= 2024.1.5) <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 python-mako-doc <!nodoc>,
 python3-doc <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-copybutton <!nodoc>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://mathema.tician.de/software/pyopencl
Vcs-Git: https://salsa.debian.org/opencl-team/python-pyopencl.git
Vcs-Browser: https://salsa.debian.org/opencl-team/python-pyopencl

Package: python3-pyopencl
Architecture: any
Multi-Arch: no
Depends:
 ocl-icd-libopencl1 | libopencl1,
 pocl-opencl-icd | mesa-opencl-icd | opencl-icd,
 python3-mako,
 python3-numpy,
 python3-pytools (>= 2024.1.5),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 python-pyopencl-doc <!nodoc>,
Suggests:
 python3-pil.imagetk,
 python3-matplotlib,
 python3-opengl,
 python3-pytest,
Description: Python 3 module to access OpenCL parallel computation API
 PyOpenCL lets you access the OpenCL parallel computation API from
 Python. Here's what sets PyOpenCL apart:
  * Object cleanup tied to lifetime of objects. This idiom, often called
    RAII in C++, makes it much easier to write correct, leak- and
    crash-free code.
  * Completeness. PyOpenCL puts the full power of OpenCL’s API at your
    disposal, if you wish.
  * Convenience. While PyOpenCL's primary focus is to make all of OpenCL
    accessible, it tries hard to make your life less complicated as it
    does so--without taking any shortcuts.
  * Automatic Error Checking. All OpenCL errors are automatically
    translated into Python exceptions.
  * Speed. PyOpenCL’s base layer is written in C++, so all the niceties
    above are virtually free.
  * Helpful, complete documentation and a wiki.
  * Liberal licensing (MIT).
 .
 This package contains Python 3 modules.

Package: python-pyopencl-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Recommends:
 python-mako-doc,
 python3-doc,
Suggests:
 python3-pyopencl,
Description: module to access OpenCL parallel computation API (documentation)
 PyOpenCL lets you access the OpenCL parallel computation API from
 Python. Here's what sets PyOpenCL apart:
  * Object cleanup tied to lifetime of objects. This idiom, often called
    RAII in C++, makes it much easier to write correct, leak- and
    crash-free code.
  * Completeness. PyOpenCL puts the full power of OpenCL’s API at your
    disposal, if you wish.
  * Convenience. While PyOpenCL's primary focus is to make all of OpenCL
    accessible, it tries hard to make your life less complicated as it
    does so--without taking any shortcuts.
  * Automatic Error Checking. All OpenCL errors are automatically
    translated into Python exceptions.
  * Speed. PyOpenCL’s base layer is written in C++, so all the niceties
    above are virtually free.
  * Helpful, complete documentation and a wiki.
  * Liberal licensing (MIT).
 .
 This package contains HTML documentation and example scripts.

=== debian/rules ===
#! /usr/bin/make -f

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export DH_VERBOSE = 1
export PYBUILD_VERBOSE=1
export VERBOSE=1
else
export DH_QUIET = 1
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

CXXFLAGS	+= $(CPPFLAGS)

BUILD_DATE=$(shell LC_ALL=C date -u "+%B %d, %Y" -d "@$(SOURCE_DATE_EPOCH)")
SPHINXOPTS:=-D today=\"$(BUILD_DATE)\"
SPHINXOPTS+=-D html_last_updated_fmt=\"$(BUILD_DATE)\"

%:
	dh $@ --buildsystem pybuild

execute_after_dh_auto_build-indep: HOME=$(CURDIR)/debian/.debhelper/generated/_source/home
execute_after_dh_auto_build-indep:
	pybuild --build -i python3 -s custom --build-args 'make -C {dir}/doc html'
	find doc/_build/html/ -name '*.html' -exec sed -r -i \
		-e 's,(<script async="async" )src(="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>),<!-- \1DISABLED\2 -->,' \
		{} +

execute_after_dh_auto_clean:
	$(RM) -r doc/_build/
	$(RM) doc/constants.inc

override_dh_auto_test:
	dh_auto_test -- -s custom --test-args="PYTHONPATH={build_dir} cp -r {dir}/test {build_dir} && cd {build_dir}/test && {interpreter} -m pytest --verbosity=2 -k 'not test_event_set_callback' && rm -rf {build_dir}/test"

execute_after_dh_auto_install-arch:
	find debian/tmp -name .gitignore -print -delete

execute_after_dh_installexamples-indep:
	hardlink -v -t debian/python-pyopencl-doc/usr/share/doc/python-pyopencl-doc

=== debian/watch ===
version=4

https://pypi.python.org/packages/source/p/@PACKAGE@/ \
@PACKAGE@-(.+)\.tar\.gz
